#ifndef FSGUI_DVIEWCONTROLDIALOG_IS_INCLUDED
#define FSGUI_DVIEWCONTROLDIALOG_IS_INCLUDED
/* { */

#include "fsgui3dviewcontrol.h"
#include <fsgui.h>

class FsGui3DViewControlDialog : public FsGuiDialog
{
private:
	FsGuiCanvas *canvas;

	FsGuiButton *openBtn,*closeBtn;

	FsGuiButton *rollLeftBtn,*noseDownBtn,*rollRightBtn;
	FsGuiButton *yawLeftBtn,*zeroAttBtn,*yawRightBtn;
	FsGuiButton *left90Btn,*noseUpBtn,*right90Btn;

	FsGuiButton *scrollUpBtn;
	FsGuiButton *scrollLeftBtn,*centerBtn,*scrollRightBtn;
	FsGuiButton *scrollDownBtn;

	FsGuiButton *lockOrientationBtn;
	FsGuiButton *lockTranslationBtn;

	FsGuiButton *frontViewBtn,*rearViewBtn;
	FsGuiButton *topViewBtn,*bottomViewBtn;
	FsGuiButton *leftViewBtn,*rightViewBtn;

	FsGuiButton *zoomBtn,*moozBtn;
	FsGuiButton *orthoPersBtn;

	FsGuiTextBox *lookAtCoordTxt;
	FsGuiButton *lookAtBtn,*lastViewBtn;
	FsGuiButton *lastLookAtBtn;
	FsGuiButton *lookAtCutBufBtn;

	FsGuiButton *noSingleBtnOpBtn,*rotateBtn,*translateBtn;

	FsGuiButton *saveViewBtn,*loadViewBtn;

	class FsGui3DViewControl *viewControl;
	friend class FsGui3DViewControl;


	class PosAttPair
	{
	public:
		YsVec3 pos;
		YsAtt3 att;
	};
	PosAttPair lastView;

private:
	FsGui3DViewControlDialog();
	~FsGui3DViewControlDialog();

public:
	/*! Creates a dialog object. */
	static FsGui3DViewControlDialog *Create(void);

	/*! Deletes a dialog object. */
	static void Delete(FsGui3DViewControlDialog *toDel);

	/*! This function makes the dialog from a view controller. */
	void Make(class FsGuiCanvas *canvas,class FsGui3DViewControl *viewControl,YSBOOL minimize=YSFALSE);

	/*! Call back function for button click. */
	virtual void OnButtonClick(FsGuiButton *btn);

	/*! This function sets lock-orientation status. */
	void SetOrientationLock(YSBOOL lock);

	/*! This function sets lock-translation status. */
	void SetTranslationLock(YSBOOL lock);

	/*! This function returns the status of "Rotate" button for single-button operation. */
	YSBOOL SingleButtonRotation(void) const;

	/*! This function returns the status of "Scroll" button for single-button operation. */
	YSBOOL SingleButtonScroll(void) const;

private:
	void Translate(double vx,double vy);
	void UpdateViewTarget(const YsVec3 &pos);
	void SaveLastView(void);
	PosAttPair RecallLastView(void);
};

/* } */
#endif
