#ifndef FSGUI_DAPP_IS_INCLUDED
#define FSGUI_DAPP_IS_INCLUDED
/* { */

#include <fsgui3d.h>

// Call back functions from the main framework. >>
YSBOOL FsGui3dAppMustTerminate(void);
int FsGui3dAppSleepIntervalInMS(void);

void FsGui3DAppInitialize(void);
void FsGui3DAppIntervalCallBack(void);
void FsGui3dAppCleanUp(void);
// Call back functions from the main framework. <<

class FsGui3DMainMenu : public FsGuiPopUpMenu
{
private:
	class FsGui3DMainCanvas *canvas;
public:
	FsGui3DMainMenu(class FsGui3DMainCanvas *canvas);
	virtual void OnSelectMenuItem(FsGuiPopUpMenuItem *item);
};

class FsGui3DMainCanvas : public FsGuiCanvas
{
public:
	enum
	{
		MENU_FILE_EXIT
	};

	FsGui3DInterface threeDInterface;
	FsGui3DViewControl drawEnv;
	FsGui3DViewControlDialog *viewControlDlg;
	FsGui3DMainMenu *mainMenu;

	FsGui3DMainCanvas();
	~FsGui3DMainCanvas();
private:
	void AddViewControlDialog(void);
	void MakeMainMenu(void);
	void DeleteMainMenu(void);

public:
	void OnInterval(void);
	void OnSelectMenuItem(FsGuiPopUpMenuItem *menuItem);
	void Draw(void);
};



/* } */
#endif
