#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#include <unistd.h>

#include <time.h>

#include <ysclass.h>

#include "fsguifiledialog.h"
#include "fsguifiledialog_mac.h"

void FsGuiFileDialog::Show(const FsGuiDialog *excludeFromDrawing) const
{
	if(YSTRUE!=busy)
	{
		FsGuiFileDialog *nonConst=(FsGuiFileDialog *)this;

		struct FsGuiFileDialog_Mac dlgInfo;
		FsGuiFileDialog_Mac_InitDialog(&dlgInfo);

		busy=YSTRUE;

		dlgInfo.in_multiSelect=(int)multiSelect;
		dlgInfo.in_mode=(mode==MODE_OPEN ? FSGUIFILEDIALOG_MAC_MODE_OPEN : FSGUIFILEDIALOG_MAC_MODE_SAVE);
		for(YSSIZE_T extIdx=0; extIdx<fileExtensionArray.GetN(); ++extIdx)
		{
			YsString utf8;
			utf8.EncodeUTF8 <wchar_t> (fileExtensionArray[extIdx]);
			FsGuiFileDialog_Mac_AddExtension(&dlgInfo,utf8);
		}



		YsWString wIniPath,wIniName;
		if(0<defaultFileName.Strlen())
		{
			if(YSOK==defaultFileName.SeparatePathFile(wIniPath,wIniName))
			{
			}
			else
			{
				char cwd[1024];
				wIniName=this->defaultFileName;
				wIniPath.SetUTF8String(getcwd(cwd,1023));
			}
		}
		else
		{
			char cwd[1024];
			wIniName.SetUTF8String("");
			wIniPath.SetUTF8String(getcwd(cwd,1023));
		}
		if(0==wIniPath.Strlen())
		{
			wIniPath.SetUTF8String(".");
		}



		YsString iniPath,iniName;
		iniPath.EncodeUTF8 <wchar_t> (wIniPath);
		iniName.EncodeUTF8 <wchar_t> (wIniName);

		dlgInfo.defaultPath=iniPath;
		dlgInfo.defaultFile=iniName;

		YsString titleUTF8;
		titleUTF8.EncodeUTF8 <wchar_t> (title);
		dlgInfo.title=titleUTF8;
		
		FsGuiFileDialog_Mac_OpenDialog(&dlgInfo);

		nonConst->res=(YSRESULT)dlgInfo.out_result;

		nonConst->selectedFileArray.Set(0,NULL);
		if(YSOK==nonConst->res)
		{
			FsGuiFileDialog_Mac_StringList *ptr;
			for(ptr=dlgInfo.out_selected; NULL!=ptr; ptr=ptr->next)
			{
				nonConst->selectedFileArray.Increment();
				nonConst->selectedFileArray.GetEnd().SetUTF8String(ptr->fn);
			}
		}

		nonConst->busy=YSFALSE;
		nonConst->selectionMade=YSTRUE;

		FsGuiFileDialog_Mac_CleanUp(&dlgInfo);

		nonConst->CloseModalDialog(res);
	}
}

void FsGuiFileDialog::AllocatePlatformSpecificData(void)
{
	param=NULL;
}

void FsGuiFileDialog::DeletePlatformSpecificData(void)
{
}
