#include <stdio.h>

#ifdef WIN32
#include <windows.h>
#endif

#include "ysbitmap.h"

#include "yspng.h"  // <- For compiling YSFLIGHT code


YSRESULT YsBitmap::LoadPng(const char fn[])
{
	YsRawPngDecoder pngDec;
	if(pngDec.Decode(fn)==YSOK)
	{
		return MoveFromYsPngDecoder(pngDec);
	}
	return YSERR;
}

YSRESULT YsBitmap::LoadPng(FILE *fp)
{
	YsRawPngDecoder pngDec;
	if(pngDec.Decode(fp)==YSOK)
	{
		return MoveFromYsPngDecoder(pngDec);
	}
	return YSERR;
}

YSRESULT YsBitmap::LoadPng(size_t nByte,const unsigned char binaryData[])
{
	YsRawPngDecoder pngDec;
	YsPngBinaryMemoryStream inStream(nByte,binaryData);
	if(pngDec.Decode(inStream)==YSOK)
	{
		return MoveFromYsPngDecoder(pngDec);
	}
	return YSERR;
}

YSRESULT YsBitmap::MoveFromYsPngDecoder(class YsRawPngDecoder &pngDec)
{
	int y;

	if(dat!=NULL)       // Fixed memory leak 2005/09/08
	{
		delete [] dat;
	}
	if(lineTop!=NULL)
	{
		delete [] lineTop;
	}

	nx=pngDec.wid;
	ny=pngDec.hei;
	dat=pngDec.rgba;

	lineTop=new unsigned char *[ny];
	for(y=0; y<(int)ny; y++)
	{
		lineTop[y]=&dat[y*4*nx];
	}

	pngDec.Flip();

	pngDec.autoDeleteRgbaBuffer=YSFALSE;

	return YSOK;
}
