#ifndef YSBASE_IS_INCLUDED
#define YSBASE_IS_INCLUDED
/* { */

#include <stdio.h>
#include "ysclassmgr.h"

// Declaration /////////////////////////////////////////////
class YsBaseClass
{
public:
	static YsClassHierarchy *ClassInfo;
	static const char *ClassName;
	virtual const char *WhatItIs(void){return YsBaseClass::ClassName;}
	virtual YsClassHierarchy *Hierarchy(void){return YsBaseClass::ClassInfo;}

	int IsKindOf(char *classname){return Hierarchy()->IsKindOf(classname);}
	static unsigned GetLeak(void){return ClassInfo->GetLeak();}

	YsBaseClass();
	YsBaseClass(const YsBaseClass &from);
	virtual ~YsBaseClass();
};

class YsNoCopyable
{
public:
	inline YsNoCopyable(){};
private:
	YsNoCopyable(const YsNoCopyable &){};
	const YsNoCopyable &operator=(const YsNoCopyable &){return *this;};
};

/* } */
#endif
