#ifndef YSBI_IS_INCLUDED
#define YSBI_IS_INCLUDED
/* { */

inline const BIPOINT &operator<<(BIPOINT &a,const YsVec3 &v)
{
	BiSetPoint(&a,v.x(),v.y(),v.z());
	return a;
}

inline const YsVec3 &operator<<(YsVec3 &v,const BIPOINT &a)
{
	v.Set(a.x,a.y,a.z);
	return v;
}


inline const BICOLOR &operator<<(BICOLOR &c,const YsColor &d)
{
	int r,g,b;
	d.GetIntRGB(r,g,b);
	BiSetColorRGB(&c,r,g,b);
	return c;
}

inline const YsColor &operator<<(YsColor &d,const BICOLOR &c)
{
	d.SetIntRGB(c.r,c.g,c.b);
	return d;
}

inline const BIANGLE &operator<<(BIANGLE &a,const YsAtt3 &b)
{
	BiSetAngleDeg(&a,YsRadToDeg(b.h()),YsRadToDeg(b.p()),YsRadToDeg(b.b()));
	return a;
}

inline const YsAtt3 &operator<<(YsAtt3 &aa,const BIANGLE &a)
{
	double h,p,b;
	h=double(a.h)*YsPi/32768;
	p=double(a.p)*YsPi/32768;
	b=double(a.b)*YsPi/32768;
	aa.Set(h,p,b);
	return aa;
}

inline const BIPOINT2 &operator<<(BIPOINT2 &v,const YsVec2 &a)
{
	BiSetPoint2(&v,a.x(),a.y());
	return v;
}

inline const BIPOINTS &operator<<(BIPOINTS &v,const YsVec2 &a)
{
	BiSetPointS(&v,a.x(),a.y());
	return v;
}

inline void YsBiMakeMatrix4x4(YsMatrix4x4 &mat,const BIPOSATT &posatt)
{
	YsVec3 pos;
	YsAtt3 att;

	pos<<posatt.p;
	att<<posatt.a;

	mat.Translate(pos);
	mat.Rotate(att);
}


// ysbishell.cpp
void YsBiDrawShell(const YsShell &shl,const YsColor &col,YSBOOL originalColor);
void YsBiDrawShellWire(const YsShell &shl,const YsShellEdgeList &edgeList,const YsColor &col);
void YsBiDrawBoundingBox(const YsVec3 &min,const YsVec3 &max,const YsColor &col,YSBOOL fill);
void YsBiDrawWireframeSphere(const YsVec3 &cen,const double &rad,const YsColor &col);
void YsBiDrawWireframeEllipsoid
    (const YsVec3 &cen,const YsMatrix4x4 &mat,const double &a,const double &b,const double &c,const YsColor &col);

/* } */
#endif
