#ifndef YSKEYWORD_IS_INCLUDED
#define YSKEYWORD_IS_INCLUDED
/* { */

#include "ysstring.h"
#include "yslist2.h"

class YsKeyWord
{
public:
	int id;
	YSSIZE_T attrib;
	class YsString str;
};

class YsKeyWordList
{
protected:
	YsListAllocator <YsKeyWord> keyWordAlloc;
	YsListContainer <YsKeyWord> keyWordList;
	YsArray <YsKeyWord *> keyWordDict;
public:
	YsKeyWordList();
	void Initialize(void);

	int GetN(void) const;
	YSRESULT MakeList(const char * const str[],const YSSIZE_T attrib[]=NULL);
	YSRESULT AddKeyWord(int nStr,const char * const str[],const YSSIZE_T attrib[]=NULL);
	YSRESULT AddKeyWord(int nStr,const YsString str[],const YSSIZE_T attrib[]=NULL);

	/*! Deprecated.  Left for backward compatibility.  Use FindIndex instead. */
	int GetId(const char str[]) const;

	/*! Returns the index to the string.  -1 will be returned if the string is not in the dictionary. */
	int FindIndex(const char str[]) const;

	const char *GetString(int id) const;

	/*! Returns the attribute of the given index. */
	YSSIZE_T GetAttribute(int idx) const;
};

/* } */
#endif
