#ifndef CONTROLDIALOG_IS_INCLUDED
#define CONTROLDIALOG_IS_INCLUDED
/* { */

#include "fsgui3dapp.h"

#define DNMCLASS_AIR_LANDINGGEAR         0
#define DNMCLASS_AIR_VGW                 1
#define DNMCLASS_AIR_AFTERBURNER         2
#define DNMCLASS_AIR_ROTOR               3
#define DNMCLASS_AIR_AIRBRAKE            4
#define DNMCLASS_AIR_FLAP                5
#define DNMCLASS_AIR_ELEVATOR            6
#define DNMCLASS_AIR_AILERON             7
#define DNMCLASS_AIR_RUDDER              8
#define DNMCLASS_AIR_BOMBBAY             9
#define DNMCLASS_AIR_NOZZLE             10
#define DNMCLASS_AIR_THRUSTREVERSER     11
#define DNMCLASS_AIR_CONCORDENOSE       12
#define DNMCLASS_AIR_CONCORDEVISOR      13
#define DNMCLASS_AIR_GEARDOOR           14
#define DNMCLASS_AIR_GEARROOMWALL       15
#define DNMCLASS_AIR_BRAKE_HOOK         16
#define DNMCLASS_AIR_GEARDOOR_FAST      17
#define DNMCLASS_AIR_BLADE_SLOW         18
#define DNMCLASS_AIR_BLADE_FAST         20
#define DNMCLASS_AIR_TURRET             21
#define DNMCLASS_AIR_TIRE               22
#define DNMCLASS_AIR_STEERING           23
#define DNMCLASS_AIR_NAVLIGHT           30
#define DNMCLASS_AIR_BEACON             31
#define DNMCLASS_AIR_STROBE             32
#define DNMCLASS_AIR_LANDINGLIGHT       33
#define DNMCLASS_AIR_LIGHTONLANDINGGEAR 34


#define DNMCLASS_GND_TURRET          1
#define DNMCLASS_GND_AAAGUN          2
#define DNMCLASS_GND_SAMTURRET       3
#define DNMCLASS_GND_SAM             4
#define DNMCLASS_GND_CANNON          5
#define DNMCLASS_GND_ROTATING       10
#define DNMCLASS_GND_ROTATING_FAST  11



class StandbyDialog : public FsGuiDialog
{
private:
	StandbyDialog(){};
	~StandbyDialog(){};

public:
	static StandbyDialog *Create(void);
	static void Delete(StandbyDialog *ptr);

	FsGui3DMainCanvas *mainCanvas;
	FsGuiButton *openButton;

	void Make(FsGui3DMainCanvas *mainCanvas);
	virtual void OnButtonClick(FsGuiButton *btn);
};

class ControlDialog : public FsGuiDialog
{
private:
	ControlDialog(){}
	~ControlDialog(){}
public:
	static ControlDialog *Create(void);
	static void Delete(ControlDialog *ptr);

	FsGui3DMainCanvas *mainCanvas;

	FsGuiColorPalette *bgColorPalette;

	FsGuiButton *afterBurnerBtn;
	FsGuiButton *lightBtn;
	FsGuiSlider *elevatorSlider;
	FsGuiSlider *aileronSlider;
	FsGuiSlider *rudderSlider;
	FsGuiSlider *flapSlider;
	FsGuiSlider *throttleSlider;
	FsGuiSlider *gearSlider;
	FsGuiSlider *nozzleSlider;
	FsGuiSlider *spoilerSlider;
	FsGuiSlider *brakeSlider;
	FsGuiSlider *reverserSlider;
	FsGuiSlider *vgwSlider;
	FsGuiSlider *bombBaySlider;
	FsGuiSlider *turretHSlider;
	FsGuiSlider *turretPSlider;
	FsGuiButton *closeButton;

	const double GetThrottle(void) const;
	const YSBOOL GetLight(void) const;

	void Make(FsGui3DMainCanvas *mainCanvas);
	virtual void OnButtonClick(FsGuiButton *btn);
	virtual void OnSliderPositionChange(FsGuiSlider *slider,const double &prevPos,const double &prevValue);
	virtual void OnColorPaletteChange(FsGuiColorPalette *plt);
};

/* } */
#endif
