#include "fsgui3dapp.h"
#include <ysport.h>

void FsGui3DMainCanvas::OpenFile(const wchar_t fn[])
{
	printf("%ls\n",fn);

	dnm.CleanUp();

	YsFileIO fp(fn,"r");
	if(NULL!=fp.Fp())
	{
		YsWString ext;
		YsWString(fn).GetExtension(ext);
		ext.Uncapitalize();
		if(0==YsWString::Strcmp(ext,L".dnm") || 0==YsWString::Strcmp(ext,L".srf"))
		{
			dnm.LoadDnm(fp.Fp());
			dnm.SetState(0);

			YsVec3 bbx[2];
			dnm.GetBoundingBox(bbx);

			bbx[0].MulZ(-1.0); // Conversion left-hand to right-hand coord.
			bbx[1].MulZ(-1.0); // Conversion left-hand to right-hand coord.

			drawEnv.SetTargetBoundingBox(bbx[0],bbx[1]);
			drawEnv.SetViewTarget((bbx[0]+bbx[1])/2.0);

			lastFileName=fn;

			if(0==YsWString::Strcmp(ext,L".dnm"))
			{
				whatToDraw=RENDER_DNM;
			}
			else if(0==YsWString::Strcmp(ext,L".srf"))
			{
				whatToDraw=RENDER_SRF;
			}
		}
		fp.Fclose();
		SetNeedRedraw(YSTRUE);
	}
}
