#ifndef FSGUI_DAPP_IS_INCLUDED
#define FSGUI_DAPP_IS_INCLUDED
/* { */

#include <fsgui3d.h>
#include <ysdnm.h>
#include <fsguifiledialog.h>

// Call back functions from the main framework. >>
YSBOOL FsGui3dAppMustTerminate(void);
int FsGui3dAppSleepIntervalInMS(void);

void FsGui3DAppInitialize(int argc,char *const argv[]);
void FsGui3DAppIntervalCallBack(void);
void FsGui3dAppCleanUp(void);
// Call back functions from the main framework. <<

class FsGui3DMainMenu : public FsGuiPopUpMenu
{
private:
	class FsGui3DMainCanvas *canvas;
public:
	FsGui3DMainMenu(class FsGui3DMainCanvas *canvas);
	virtual void OnSelectMenuItem(FsGuiPopUpMenuItem *item);
};

class FsGui3DMainCanvas : public FsGuiCanvas
{
public:
	enum
	{
		MENU_FILE_EXIT,
		MENU_FILE_OPEN,
	};

	FsGui3DInterface threeDInterface;
	FsGui3DViewControl drawEnv;
	FsGui3DViewControlDialog *viewControlDlg;
	FsGui3DMainMenu *mainMenu;
	FsGuiFileDialog fileDialog;

	class StandbyDialog *standbyDlg;
	class ControlDialog *controlDlg;

	enum RENDER_TARGET
	{
		RENDER_NONE,
		RENDER_DNM,
		RENDER_SRF,
	};
	RENDER_TARGET whatToDraw;
	YsWString lastFileName;
	YsDnm dnm;
	double t;
	YSBOOL night;

	YsColor bgCol;

	FsGui3DMainCanvas();
	~FsGui3DMainCanvas();
private:
	void AddViewControlDialog(void);
	void MakeMainMenu(void);
	void DeleteMainMenu(void);

public:
	void OnInterval(void);
	void OnSelectMenuItem(FsGuiPopUpMenuItem *menuItem);
	void Draw(void);
	void OpenFile(const wchar_t fn[]);

	void FileOpen(void);
	static void FileOpenCallBack(FsGuiControlBase *canvas,FsGuiDialog *,int returnCode);
};


/* } */
#endif
