#include "ysglslsharedrenderer.h"

static struct YsGLSL3DRenderer *ysGLSLFlat3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLVariColorBillBoard3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLMonoColorBillBoard3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLFlash3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLVariColor3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLMonoColorPerVtxShading3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLMonoColorPerPixShading3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLVariColorPerVtxShading3DRenderer=NULL;
static struct YsGLSL3DRenderer *ysGLSLVariColorPerPixShading3DRenderer=NULL;
static struct YsGLSLPlain2DRenderer *ysGLSLPlain2DRenderer=NULL;
static struct YsGLSLBitmapRenderer *ysGLSLBitmapRenderer=NULL;


static YSBOOL usePerPixRendering=YSFALSE;

#define YSGLSL_BIGENOUGH_BUT_NOTTOOBIG_NUMBER 16

static struct YsGLSL3DRenderer **GetAll3DRenderer(void)
{
	static struct YsGLSL3DRenderer *all3dRenderer[YSGLSL_BIGENOUGH_BUT_NOTTOOBIG_NUMBER];

	int i=0;
	all3dRenderer[i++]=ysGLSLFlat3DRenderer;
	all3dRenderer[i++]=ysGLSLVariColorBillBoard3DRenderer;
	all3dRenderer[i++]=ysGLSLMonoColorBillBoard3DRenderer;
	all3dRenderer[i++]=ysGLSLFlash3DRenderer;
	all3dRenderer[i++]=ysGLSLVariColor3DRenderer;
	all3dRenderer[i++]=ysGLSLMonoColorPerVtxShading3DRenderer;
	all3dRenderer[i++]=ysGLSLMonoColorPerPixShading3DRenderer;
	all3dRenderer[i++]=ysGLSLVariColorPerVtxShading3DRenderer;
	all3dRenderer[i++]=ysGLSLVariColorPerPixShading3DRenderer;
	all3dRenderer[i++]=NULL;
	return all3dRenderer;
}

static struct YsGLSL3DRenderer **GetAll3DRendererWithLight(void)
{
	static struct YsGLSL3DRenderer *all3DRendererWithLight[YSGLSL_BIGENOUGH_BUT_NOTTOOBIG_NUMBER];

	int i=0;
	all3DRendererWithLight[i++]=ysGLSLMonoColorPerVtxShading3DRenderer;
	all3DRendererWithLight[i++]=ysGLSLMonoColorPerPixShading3DRenderer;
	all3DRendererWithLight[i++]=ysGLSLVariColorPerVtxShading3DRenderer;
	all3DRendererWithLight[i++]=ysGLSLVariColorPerPixShading3DRenderer;
	all3DRendererWithLight[i++]=NULL;
	return all3DRendererWithLight;
}



YSRESULT YsGLSLCreateSharedRenderer(void)
{
	if(NULL==ysGLSLFlat3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLFlat3DRenderer=YsGLSLCreateFlat3DRenderer();
	}
	if(NULL==ysGLSLVariColorBillBoard3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLVariColorBillBoard3DRenderer=YsGLSLCreateVariColorBillBoard3DRenderer();
	}
	if(NULL==ysGLSLMonoColorBillBoard3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLMonoColorBillBoard3DRenderer=YsGLSLCreateMonoColorBillBoard3DRenderer();
	}
	if(NULL==ysGLSLFlash3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLFlash3DRenderer=YsGLSLCreateFlash3DRenderer();
	}
	if(NULL==ysGLSLVariColor3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLVariColor3DRenderer=YsGLSLCreateVariColor3DRenderer();
	}
	if(NULL==ysGLSLMonoColorPerVtxShading3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLMonoColorPerVtxShading3DRenderer=YsGLSLCreateMonoColorPerVtxShading3DRenderer();
	}
	if(NULL==ysGLSLMonoColorPerPixShading3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLMonoColorPerPixShading3DRenderer=YsGLSLCreateMonoColorPerPixShading3DRenderer();
	}
	if(NULL==ysGLSLVariColorPerVtxShading3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLVariColorPerVtxShading3DRenderer=YsGLSLCreateVariColorPerVtxShading3DRenderer();
	}
	if(NULL==ysGLSLVariColorPerPixShading3DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLVariColorPerPixShading3DRenderer=YsGLSLCreateVariColorPerPixShading3DRenderer();
	}

	if(NULL==ysGLSLPlain2DRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLPlain2DRenderer=YsGLSLCreatePlain2DRenderer();
	}

	if(NULL==ysGLSLBitmapRenderer)
	{
		printf("%s %d\n",__FUNCTION__,__LINE__);
		ysGLSLBitmapRenderer=YsGLSLCreateBitmapRenderer();
	}

	return YSOK;
}

YSRESULT YsGLSLDeleteSharedRenderer(void)
{
	if(NULL!=ysGLSLFlat3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLFlat3DRenderer);
		ysGLSLFlat3DRenderer=NULL;
	}
	if(NULL!=ysGLSLFlash3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLFlash3DRenderer);
		ysGLSLFlash3DRenderer=NULL;
	}
	if(NULL!=ysGLSLVariColorBillBoard3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLVariColorBillBoard3DRenderer);
		ysGLSLVariColorBillBoard3DRenderer=NULL;
	}
	if(NULL!=ysGLSLMonoColorBillBoard3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLMonoColorBillBoard3DRenderer);
		ysGLSLMonoColorBillBoard3DRenderer=NULL;
	}
	if(NULL!=ysGLSLVariColor3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLVariColor3DRenderer);
		ysGLSLVariColor3DRenderer=NULL;
	}
	if(NULL!=ysGLSLMonoColorPerVtxShading3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLMonoColorPerVtxShading3DRenderer);
		ysGLSLMonoColorPerVtxShading3DRenderer=NULL;
	}
	if(NULL!=ysGLSLMonoColorPerPixShading3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLMonoColorPerPixShading3DRenderer);
		ysGLSLMonoColorPerPixShading3DRenderer=NULL;
	}
	if(NULL!=ysGLSLVariColorPerVtxShading3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLVariColorPerVtxShading3DRenderer);
		ysGLSLVariColorPerVtxShading3DRenderer=NULL;
	}
	if(NULL!=ysGLSLVariColorPerPixShading3DRenderer)
	{
		YsGLSLDelete3DRenderer(ysGLSLVariColorPerPixShading3DRenderer);
		ysGLSLVariColorPerPixShading3DRenderer=NULL;
	}

	if(NULL!=ysGLSLPlain2DRenderer)
	{
		YsGLSLDeletePlain2DRenderer(ysGLSLPlain2DRenderer);
		ysGLSLPlain2DRenderer=NULL;
	}

	if(NULL!=ysGLSLBitmapRenderer)
	{
		YsGLSLDeleteBitmapRenderer(ysGLSLBitmapRenderer);
		ysGLSLBitmapRenderer=NULL;
	}


	return YSOK;
}

struct YsGLSL3DRenderer *YsGLSLSharedFlat3DRenderer(void)
{
	return ysGLSLFlat3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedVariColorBillBoard3DRenderer(void)
{
	return ysGLSLVariColorBillBoard3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedMonoColorBillBoard3DRenderer(void)
{
	return ysGLSLMonoColorBillBoard3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedFlash3DRenderer(void)
{
	return ysGLSLFlash3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedVariColor3DRenderer(void)
{
	return ysGLSLVariColor3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedMonoColorPerVtxShading3DRenderer(void)
{
	return ysGLSLMonoColorPerVtxShading3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedMonoColorPerPixShading3DRenderer(void)
{
	return ysGLSLMonoColorPerPixShading3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedVariColorPerVtxShading3DRenderer(void)
{
	return ysGLSLVariColorPerVtxShading3DRenderer;
}

struct YsGLSL3DRenderer *YsGLSLSharedVariColorPerPixShading3DRenderer(void)
{
	return ysGLSLVariColorPerPixShading3DRenderer;
}

struct YsGLSLPlain2DRenderer *YsGLSLSharedPlain2DRenderer(void)
{
	return ysGLSLPlain2DRenderer;
}

struct YsGLSLBitmapRenderer *YsGLSLSharedBitmapRenderer(void)
{
	return ysGLSLBitmapRenderer;
}

////////////////////////////////////////////////////////////

void YsGLSLSetPerPixRendering(YSBOOL perPix)
{
	usePerPixRendering=perPix;
}

struct YsGLSL3DRenderer *YsGLSLSharedMonoColorShaded3DRenderer(void)
{
	if(YSTRUE==usePerPixRendering)
	{
		return YsGLSLSharedMonoColorPerPixShading3DRenderer();
	}
	else
	{
		return YsGLSLSharedMonoColorPerVtxShading3DRenderer();
	}
}

struct YsGLSL3DRenderer *YsGLSLSharedVariColorShaded3DRenderer(void)
{
	if(YSTRUE==usePerPixRendering)
	{
		return YsGLSLSharedVariColorPerPixShading3DRenderer();
	}
	else
	{
		return YsGLSLSharedVariColorPerVtxShading3DRenderer();
	}
}

YSRESULT YsGLSLSetShared3DRendererAlphaCutOff(GLfloat alphaCutOff)
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRenderer();

	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererAlphaCutOff(rendererArray[i],alphaCutOff);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererFog(int enableFog,const GLfloat density,const GLfloat fogColor[4])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRenderer();

	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererUniformFogEnabled(rendererArray[i],enableFog);
		YsGLSLSet3DRendererUniformFogDensity(rendererArray[i],density);
		YsGLSLSet3DRendererUniformFogColor(rendererArray[i],fogColor);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererProjection(const GLfloat proj[16])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRenderer();

	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererProjectionfv(rendererArray[i],proj);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererModelView(const GLfloat modelview[16])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRenderer();
	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererModelViewfv(rendererArray[i],modelview);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererDirectionalLightfv(int lightIdx,const GLfloat dir[3])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRendererWithLight();
	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererUniformLightDirectionfv(rendererArray[i],lightIdx,dir);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererLightColor(int idx,const GLfloat color[3])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRendererWithLight();
	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererLightColor(rendererArray[i],idx,color);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererAmbientColor(const GLfloat color[3])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRendererWithLight();
	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererAmbientColor(rendererArray[i],color);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererSpecularColor(const GLfloat color[3])
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRendererWithLight();
	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererSpecularColor(rendererArray[i],color);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}

YSRESULT YsGLSLSetShared3DRendererSpecularExponent(const GLfloat exponent)
{
	GLuint prevProgramId;
	struct YsGLSL3DRenderer **rendererArray;
	int i;

	rendererArray=GetAll3DRendererWithLight();
	glGetIntegerv(GL_CURRENT_PROGRAM,(GLint *)&prevProgramId);

	for(i=0; NULL!=rendererArray[i]; ++i)
	{
		YsGLSLUse3DRenderer(rendererArray[i]);
		YsGLSLSet3DRendererSpecularExponent(rendererArray[i],exponent);
		YsGLSLEndUse3DRenderer(rendererArray[i]);
	}

	glUseProgram(prevProgramId);

	return YSOK;
}


